#include "Osoba.h"

Osoba::Osoba(const char* im, const char* naz)
{
	cout << "Konstruktor zwykly obiektu ";
	imie = new char[strlen(im)+1]; //+1 => '\0'
	nazwisko = new char[strlen(naz)+1];
	strcpy(imie, im);
	strcpy(nazwisko, naz);
	Wypisz();
}

Osoba::~Osoba()
{
	cout << "Destruktor obiektu ";
	if(imie&&nazwisko)Wypisz();

	delete[] imie;
	delete[] nazwisko;
	imie = nullptr;
	nazwisko = nullptr;

}

void Osoba::Wypisz()
{
	cout << imie << ' ' << nazwisko << endl;
}

void Osoba::WypiszExtra()
{
	cout << "My name is " << nazwisko << ',';
	Wypisz();
}

void Osoba::ZmienImie(const char* nowe)
{
	delete[]imie;
	imie = new char[strlen(nowe) + 1];
	strcpy(imie, nowe);
}

Osoba::Osoba(const Osoba& wzor)
{
	cout << "Konstruktor kopiujacy obiektu ";

	imie = new char[strlen(wzor.imie)+1];
	nazwisko = new char[strlen(wzor.nazwisko)+1];

	strcpy(imie, wzor.imie);
	strcpy(nazwisko, wzor.nazwisko);

	Wypisz();
}

Osoba& Osoba::operator=(const Osoba& wzor)
{	//Tak generuje
	//imie = wzor.imie;
	//nazwisko = wzor.nazwisko;
	cout << "Operator= obiektu ";

	if (this != &wzor)
	{
		// cz destruktorowa
		//delete[] imie;
		//delete[] nazwisko;
		this->~Osoba();
		//Osoba::~Osoba();

		//cz konstruktora kopiujcego

		//imie = new char[strlen(wzor.imie) + 1];
		//nazwisko = new char[strlen(wzor.nazwisko) + 1];

		//strcpy(imie, wzor.imie);
		//strcpy(nazwisko, wzor.nazwisko);
		//this->Osoba::Osoba(wzor); //VS
		new (this) Osoba(wzor);
	}

	Wypisz();

	return *this;
}

