#include "Napis.h"


Napis::Napis(const char* a)
{
	dl = strlen(a);
	s = new char[dl + 1];
	strcpy(s, a);
}

Napis::~Napis()
{
	if (s)delete[]s;
	s = nullptr;	//s = 0; //s=NULL;
	dl = 0;
}

void Napis::Wypisz() const
{
	cout << s << endl;
}

void Napis::Nadpisz(const char* nowy)
{
	strncpy(s, nowy, dl);
	s[dl] = '\0';
}

void Napis::Nowy(const char* nowy)
{
	delete[]s;
	dl = strlen(nowy);
	s = new char[dl + 1];
	strcpy(s, nowy);
}

Napis::Napis(const Napis& wzor)
{
	dl = wzor.dl;
	s = new char[dl + 1];
	strcpy(s, wzor.s);
}

Napis& Napis::operator=(const Napis& wzor)
{
	if (this != &wzor)
	{
		delete[]s;
		dl = wzor.dl;
		s = new char[dl + 1];
		strcpy(s, wzor.s);
	}
	return *this;
}

void Napis::operator+=(const char* n)
{
	if (n == nullptr || *n == '\0')return;
	if (s == nullptr)
	{
		dl = strlen(n);
		s = new char[dl + 1];
		strcpy(s, n);
	}
	else
	{
		dl += strlen(n);
		char* ns = new char[dl + 1];
		strcpy(ns, s);
		strcat(ns, n);
		delete[]s;
		s = ns;
	}
}

